;ͻ
;  SCRIPT NAME : SKINSERT.SC                                                 
;ͼ
;  by Anthony Lee      DATE : 12/07/88     TIME :         
;ͻ
;  PURPOSE    : To transfer the contents of an existing Paradox table        
;               into the Sidekick table.                                     
;                                                                            
;                                                                            
;                                                                            
;ͼ


If isfile("SKInsert.lib") then
  Run "Del SKInsert.lib"
Endif

Libname = "SKInsert"
Createlib Libname

;ͻ
;  Driver script : SKINSERT.SC                                               
;ͼ
;
;--------------------------------------------------------------------------
;Begin main script - SKINSERT.SC
;Necessary tables : SKINSERT.DB and SKSTRUCT.DB
;
;
;Autolib = "SKInsert"
;Array target[14]
;Array source[14]
;
;GetSKTable()
;GetInsTable()
;RestructureIns()
;InitializeSKInsert()
;EditSKInsert()
;BuildQuery()
;ExitSKInsert()
;
;Clearall
;View SKTable
;
;Release Vars SKTable



Proc GetSKTable() ;-----------------------------------------------------------
;Ask for a valid SideKick table
;
private SKFields, Choice

Clear
Clearall

style attribute 30
@1,0 ?? format("W76,AC","SideKick PhoneBook Utility")
style attribute 27
@2,0 ?? format("W76,AC","Transfers a Paradox table to the PhoneBook")


style attribute 94
@4,4  ??" ͻ "
@5,4  ??"                                                                  "
@6,4  ??"  Which SideKick Phonebook table do you wish to add to:           "
@7,4  ??"     <                                                      >     "
@8,4  ??"                                                                  "
@9,4  ??" ͼ "

style attribute 31
@22,7 ?? "Please enter a tablename or press <Esc> to exit.  "
style attribute 30
@24,7 ?? "(For instructions, see the file SIDEKICK on your Sample Tables Disk)"


While true
  Style Attribute 30
  @7,12 Accept "A52" Picture "*!" to sktable
  cursor off
  Switch
    Case retval = false    :           ;User pressed <Esc>
      ExitSKInsert()  Quit
    Case isblank(sktable)  :           ;User did not input a table name
      @20,7 clear eol
    Case sktable="STRUCT" or sktable="SKTABLE"   :
      @20,7 ??"You may not select the ",sktable," table."
      Clear eol                        ;Valid tablename
    Case istable(sktable)  :           ;Check if valid SK Structure
      @20,7 ??"Checking to see if valid SideKick Phonebook table"
      Style Attribute 158
      ??"....."
      clear eol
      style

      {Tools} {Info} {Structure} {SKtable}
      Rename "Struct" "SKStruct"
      {Tools} {Info} {Structure} select sktable
      SKFields = nrecords("Struct")
      Subtract "SKStruct" "Struct"
      Delete "SKStruct"

      If isempty("Struct") and SKFields = 14 then
        delete "struct"
        quitloop
      Else
        @20,7 ??SKtable," is not a valid SideKick table."
        Clear eol
      Endif
    Otherwise              :           ;Table does not exist
      @20,7 ?? sktable," is not a tablename."
      Clear eol
      @22,7 ?? "Is this a new SideKick Phonebook table?"
      Style Attribute 158
      ?? " _"
      clear eol
      choice = getchar()
      if (choice = 89) or (choice = 121) then
        Create sktable like "Sktable"
        quitloop
      else
        style attribute 31
        @22,7 ?? "Please enter a tablename or press <Esc> to exit."
        style attribute 30
      endif
  Endswitch
cursor normal
Endwhile

Endproc
Writelib Libname GetSKTable
Release Procs GetSKTable


Proc GetInsTable() ;---------------------------------------------------------
;Ask for a table to insert
;

Style Attribute 94
@11,4 ??" ͻ "
@12,4 ??"                                                                  "
@13,4 ??"  What table do you wish to insert:                               "
@14,4 ??"     <                                                      >     "
@15,4 ??"                                                                  "
@16,4 ??" ͼ "


@20,7 Clear eol
style attribute 31
@22,7 ?? "Please enter a tablename or press <Esc> to exit.  "


While true
  Style Attribute 30
  @14,12 Accept "A52" Picture "*!" to instable
  cursor off
  Switch
    case retval = false    :           ;User pressed <Esc>
      clearall
      ExitSKInsert()  Quit
    case instable = sktable:           ;Can't add table to itself
      @20,7 ??"You may not add a table to itself."
      Clear eol
    Case isblank(instable) :           ;User didn't enter a tablename
      @20,7 clear eol
    Case instable="STRUCT" or instable="SKTABLE"   :
      @20,7 ??"You may not select the ",instable," table."
      Clear eol                        ;Valid tablename
    Case istable(instable) :
      quitloop
    Otherwise              :           ;table not found
      @20,7 ?? instable," is not a tablename."
      Clear eol
  Endswitch
  cursor normal
Endwhile

@20,7 ??"Preparing ",instable," table"
Style Attribute 158
??"....."
clear eol
@22,0 clear eol

Endproc
Writelib Libname GetInsTable
Release Procs GetInsTable


Proc RestructureIns() ;-----------------------------------------------------
;Create the Structure for the selected table
;

Menu {Tools} {Info} {Structure} select instable
Rename "Struct" "I_Struct"
SetPopup("I_Struct")

Copy instable "I_Table"
Menu {Modify} {Restructure} {I_Table}
moveto [Field Type]
scan
  Switch
    Case [Field Type] = "N" : Backspace  Typein "A24"
    Case [Field Type] = "S" : Backspace  Typein "A7"
    Case [Field Type] = "$" : Backspace  Typein "A24"
    Case [Field Type] = "D" : Backspace  Typein "A10"
  EndSwitch
Endscan
Do_it!

EndProc
Writelib Libname RestructureIns
Release Procs RestructureIns


Proc InitializeSKInsert() ;--------------------------------------------------
;Empty the SKInsert columns
;

Clearall
Menu {Ask} {SKInsert}
[Field Name] = "changeto blank"
[Field Type] = "changeto blank"
Do_it!

;Define the Valcheck using the selected table as a tablelookup
;
Clearall
Edit "SKInsert"
Moveto [Field Name]
Menu {Valcheck} {Define} Moveto [Field Name] Enter
{Tablelookup} CtrlBackspace Typein "I_Struct" Enter
{AllCorrespondingFields} {HelpAndFill}
Do_it!

Endproc
Writelib Libname InitializeSKInsert
Release Procs InitializeSKInsert



Proc EditSKInsert() ;---------------------------------------------------------
;Edit the SKInsert table to find out where the fields should go
;
Private choice

Edit "SKInsert"
While True
  Style Attribute 30
  Wait Field
    Prompt "Press <F1> for list of fields,  <F2> when done, <Esc> to quit.",
           "Use the up and down arrows to move from record to record."
  Until "F1", "F2", "Up", "Down", "Esc"

  Switch
    Case retval = "F1"   :
      Echo normal  Echo off
      @21,4 ??"Please select the field to transfer to the Sidekick "
      Style Attribute 63
      ?? "[" , [Target Field Name], "]"
      Style Attribute 30
      ?? " field"
      Popup(5,45,1,7)
      [] = retval               ;Assign selection to [Field Name]
    Case retval = "F2"   :
      Scan
        Source[recno()] = [Field Name]
      Endscan
      If isblank(source[1]) and isblank(source[2]) and
         isblank(source[3]) and isblank(source[4]) then
        @20,10 ??"Please make an entry in one of the key fields."
        sleep 2500
        Home
        loop
      Endif

      echo normal  echo off cursor off
      @20,0 ?? format("W80,AC","Are these all the fields you wish to include")
      @21,0 ?? format("W80,AC","in your SideKick Phonebook table? (Y/N) ")
      choice = getchar()
      If (choice = 89) or (choice = 121) then
        @20,10 ?? "Processing Query"
        Style Attribute 158
        ??"....."
        clear eol
        @21,0 clear eol
        Do_it!  Quitloop
      else
        Home
      Endif
      @20,10 clear eol
    Case retval = "Up"   :
      If recno() <> 1 then
        CheckEntry("Up")
      else
        beep
      endif
    Case retval = "Down" :
      If recno() <> 14 then
        CheckEntry("Down")
      else
        beep
      Endif
    Case retval = "Esc"  :
      Do_it!
      Clearall
      ExitSKInsert()
      Quit
    Otherwise            :
      Beep
  Endswitch
Endwhile

Endproc
Writelib Libname EditSKInsert
Release Procs EditSKInsert


Proc CheckEntry(MoveDirection) ;----------------------------------------------
;Check for move direction and error trapping
;

if isblank([Field Name]) then
  [Field Type] = ""
endif

If MoveDirection = "Up" then
  up down
else
  down up
Endif

If (substr([Field Type],1,1) = "N" or substr([Field Type],1,1) = "$")
  and (numval(substr([Tar Fld type],2,2)) < 25) then
  @20,10 ??"Digits may be truncated from the "
  Style Attribute 63
  ?? "[",[Field Name], "]"
  Style Attribute 30
  ?? " field."
  @21,10 ??"  OK to continue? (Y/N) "
  choice = getchar()
  if (choice = 89) or (choice = 121) then
    execute MoveDirection
  else
    [Field Name] = ""
    [Field Type] = ""
    return
  endif
else
  execute MoveDirection
endif

Endproc
Writelib Libname CheckEntry
Release Procs CheckEntry


Proc BuildQuery() ;-----------------------------------------------------------
;Fill the array with Field Names of target and source
;

Scan
  Target[recno()] = [Target Field Name]
  Source[recno()] = [Field Name]
Endscan


;Fill in the query
;

Clearall
Menu {Ask} select sktable  typein "insert"
Menu {Ask} select "I_Table"

For x from 1 to 14
  If not isblank(source[x]) then
    Moveto sktable
    Moveto field target[x]
    [] = "_" + strval(x)

    Moveto "I_Table"
    Moveto field source[x]
    If isblank([]) then
      [] = "_" + strval(x)
    else
      [] = [] + ", _" + strval(x)
    Endif
  Endif
Endfor

Do_it!

Endproc
Writelib Libname BuildQuery
Release Procs BuildQuery


Proc ExitSKInsert() ;--------------------------------------------------------
;Release all variables when user quits application
;
if not isassigned(sktable) then quit
endif
if not isblank(sktable) and istable(sktable) and isempty(sktable) then
  delete sktable
endif

Release Vars Target,Source,Instable,Autolib,
             PopupLen,PopupList,PopupNumber,PopupStart

If istable("I_Table")  then Delete "I_Table"  Endif
If istable("I_Struct") then Delete "I_Struct" Endif
If istable("Inserted") then Delete "Inserted" Endif
If istable("Struct")   then Delete "Struct"   Endif
If istable("Changed")  then Delete "Changed"  Endif


Play "AJL"


Endproc
WriteLib Libname ExitSKInsert
Release Procs ExitSKInsert







;ͻ
;  Popup Procedures: SetPopup, Popup, PopDraw, PopRedraw                     
;ͼ


Proc SetPopup(Tables) ;-------------------------------------------------------
   Private;Tables,            ;List of tables for which to define popup menus
           TempName,          ;Array which stores the names of each table
           NumMenus,          ;Number of tables specified in "Tables" parameter
           NumItems,          ;Number of items in current table
           CurrTable,         ;Current table being looked at
           X                  ;Loop index
   Array TempName[10]
   Array PopupStart[10]       ;Stores pointer to beginning of item list
   Array PopupNumber[10]      ;Stores number of items in menu list
   Array PopupLen[10]         ;Stores length of longest menu choice
   NumMenus=0
   NumItems=0
   Tables=Tables+","
   While match(Tables,"..,..",CurrTable,Tables)    ;Process each table name
      If not istable(CurrTable)
         Then Quit "Table "+CurrTable+" does not exist."
      Endif
      NumMenus=NumMenus+1                          ;Update which menu this is
      TempName[NumMenus]=CurrTable
      PopupStart[NumMenus]=NumItems                ;NumItems is a running total
      NumItems=NumItems+nrecords(CurrTable)
   Endwhile
   If NumItems<>0
      Then Array PopupList[NumItems]  ;Stores all line items from data tables
   Endif
   For X from 1 to NumMenus
      If isempty(TempName[X])
         Then PopupNumber[X]=0
         Else View TempName[X]
              Right
              PopupNumber[X]=0
              PopupLen[X]=0
              Scan
                 PopupLen[X]=max(PopupLen[X],len([])+4)      ;Update max width
                 PopupNumber[X]=PopupNumber[X]+1
                 PopupList[PopupNumber[X]+PopupStart[X]]=[]  ;Store line item
              Endscan
              PopupLen[X]=max(PopupLen[X],10)
              ClearImage
      Endif
   Endfor
Endproc
Writelib Libname SetPopup
Release Procs SetPopup


Proc Popup(R,C,Num,Size) ;----------------------------------------------------
   Private;R,       ;Row position of popup window
          ;C,       ;Column position of popup window
          ;Num,     ;Popup menu number
          ;Size,    ;Number of choices to be displayed at one time
           Char,    ;Last key that was pressed
           MenuPos, ;Current position within menu
           Choice,  ;Current menu selection
           X        ;Counter
   If PopupNumber[Num]=0
      Then Return ""
   Endif
   If Size>PopupNumber[Num]
      Then Size=PopupNumber[Num]
   Endif
   Echo Off
   Cursor Off
   @0,0
   ?? "Highlight the appropriate selection using the cursor movement keys."
   Clear Eol
   ? "Press [Enter] to accept, [Esc] to cancel menu selection."
   Clear Eol
   ;Draw menu box
   @R,C
   ?? "",fill("",PopupLen[Num]-2),""
   @R+1,C
   ?? " CHOOSE:",spaces(PopupLen[Num]-10),""
   @R+2,C
   ?? "",fill("",PopupLen[Num]-2),""
   For X from 1 to Size
      @R+2+X,C
      ?? " ",substr(strval(PopupList[PopupStart[Num]+X])+
              spaces(PopupLen[Num]),1,PopupLen[Num]-3),""
   Endfor
   @R+3+Size,C
   ?? "",fill("",PopupLen[Num]-2),""
   If Size<>PopupNumber[Num]      ;Is there more data that can't be displayed?
      Then @R+2+Size,C+1
           ?? ""                 ;Show that more items exist below
   Endif
   MenuPos=1
   Choice=1
   While True
      Style Reverse               ;Highlight current selection
      PopDraw()
      Style
      Char=getchar()
      Switch
         Case Char=-72:                          ;Key was [Up]
            If Choice=1                          ;Are we already at the top?
               Then Beep
               Else If MenuPos>1                 ;Can we move within the menu?
                       Then PopDraw()            ; Yes- Blank current selection
                            MenuPos=MenuPos-1    ;      Move window position
                       Else PopRedraw(Choice-2)  ; No-  Redraw entire menu
                    Endif
                    Choice=Choice-1              ;Select new choice
            Endif
         Case Char=-80:                          ;Key was [Down]
            If Choice=PopupNumber[Num]           ;Are we already at the bottom?
               Then Beep
               Else If MenuPos<Size              ;Can we move within the menu?
                       Then PopDraw()            ; Yes- Blank current selection
                            MenuPos=MenuPos+1    ;      Move window position
                       Else PopRedraw(Choice-Size+1); No-  Redraw entire menu
                    Endif
                    Choice=Choice+1              ;Select new choice
            Endif
         Case Char=-71:                          ;Key was [Home]
            If MenuPos=Choice                    ;Is first selection on screen?
               Then PopDraw()                    ; Yes- Blank current selection
               Else PopRedraw(0)                 ; No-  Redraw menu from start
            Endif
            MenuPos=1                            ;Position at first item
            Choice=1                             ;Select first item
         Case Char=-79:                          ;Key was [End]
            If Choice+Size-MenuPos=PopupNumber[Num];Is last selection on screen?
               Then PopDraw()                    ; Yes- Blank current selection
               Else PopRedraw(PopupNumber[Num]-Size); No-  Redraw end of menu
            Endif
            MenuPos=Size                         ;Position at bottom of menu
            Choice=PopupNumber[Num]              ;Select last item
         Case Char=-73:                          ;Key was [PgUp]
            If MenuPos=Choice                    ;Are we within first screen?
               Then Beep                         ; Yes- Disallow PgUp
               Else If Choice-MenuPos-Size>0
                       Then Choice=Choice-MenuPos-Size+1
                       Else Choice=1
                    Endif
                    PopRedraw(Choice-1)          ; No-  Redraw previous page
                    MenuPos=1                    ;   Position on that item
            Endif
         Case Char=-81:                          ;Key was [PgDn]
            If Choice+Size-MenuPos=PopupNumber[Num];Are we within last screen?
               Then Beep                           ; Yes- Disallow PgDn
               Else If PopupNumber[Num]-Size<Choice+Size-MenuPos
                       Then Choice=PopupNumber[Num]-Size+1
                       Else Choice=Choice+Size-MenuPos+1
                    Endif
                    PopRedraw(Choice-1)            ; No- Redraw next page
                    MenuPos=1                      ;     Position on that item
            Endif
         Case Char=13:                             ;Key was [Enter]
            Cursor Normal
            Return PopupList[PopupStart[Num]+Choice]       ;Return selection
         Case Char=27:                             ;Key was [Esc]
            Cursor Normal
            Return ""
         Otherwise:                                ;Illegal key
            Beep
      Endswitch
   Endwhile
Endproc
Writelib Libname Popup
Release Procs Popup


Proc PopDraw() ;--------------------------------------------------------------
   @MenuPos+R+2,C+2
   ?? PopupList[PopupStart[Num]+Choice]
Endproc
Writelib Libname PopDraw
Release Procs PopDraw


Proc PopRedraw(Start) ;-------------------------------------------------------
;Private Start           ;Location within PopupList to begin redraw
   For Z from 1 to Size            ;Redraw all information in the menu box
      @R+Z+2,C+2
      ?? substr(strval(PopupList[PopupStart[Num]+Start+Z])+
         spaces(PopupLen[Num]),1,PopupLen[Num]-3)
   Endfor
   @R+3,C+1
   If Start=0          ;Are there records above?
      Then ?? " "      ; No- Remove up arrow
      Else ?? ""      ; Yes- Place up arrow to signify more records
   Endif
   @R+Size+2,C+1
   If Start+Size=PopupNumber[Num]  ;Are there records below?
      Then ?? " "                  ; No- Remove down arrow
      Else ?? ""                  ; Yes- Place down arrow to signify more
   Endif
Endproc
Writelib Libname PopRedraw
Release Procs PopRedraw


